'''
    Game main module.
'''

import data
import sys
import pygame
# Standard Init.
pygame.init()
from random import *
from pygame.locals import *
from bridgesprites import *
from pygame import *
from blevels import *
# Sound.
pygame.mixer.init()
#pman8.wav flatfly
#http://www.freesound.org/samplesViewSingle.php?id=17633
yeahtreasure = pygame.mixer.Sound("media/17633__flatfly__pman8.wav")
yeahtreasure.set_volume(1)
ouch = pygame.mixer.Sound("media/ouch.wav")
ouch.set_volume(1)

screen = pygame.display.set_mode([640,600])
pygame.display.set_caption("Wibbly Wobbly Bridge")

# GFX.
backgroundwater = pygame.image.load('media/water.jpg')
inst = pygame.image.load('media/inst.png')

def CreateBackground():
  background = pygame.Surface(screen.get_size())
  background = background.convert()
  #screen.blit(backgroundwater, [0, 0, 640, 600])
  return background

# GFX Functions
def DrawText(background, x, y, text, size=24, color=(255, 255, 255)):
    inst1_font = pygame.font.Font(None, size)
    inst1_surf = inst1_font.render(text, 1, color)
    background.blit(inst1_surf, [x, y])

def DrawBG(background, B_Left, BridgeWidth, Bars):
    #Bridge.
    background.blit(backgroundwater, [0, 0, 640, 600])
    background.fill((166,166,166), [B_Left, 0, BridgeWidth, 600] )
    background.fill((6,6,6), [B_Left, 0, Bars, 600] )
    background.fill((6,6,6), [B_Left+(BridgeWidth-Bars), 0, Bars, 600] )
    
def DrawMan(background, B_Left, X, Y):
    pygame.draw.circle(background,(255,0,0),(B_Left+X,Y),10)
    
#------ 
# MAIN
#------
def main():
    GameState = 0
    Bloke = Man()
    #Obs1 = Box()
    #Obs2 = Box()
    #Obs3 = Box()
    #MB1 = MBox()
    #FB1 = Fireball()
    Treas1 = Treasure()
    allsprites = pygame.sprite.RenderPlain(Bloke)
    #Obssprites = pygame.sprite.RenderPlain(Obs1,Obs2,Obs3,MB1,FB1)
    treasprites = pygame.sprite.RenderPlain(Treas1)
    while GameState<>-1:
        
        if GameState == 0:
          print "Title Screen"
          MyShip = Treasure()
          background = CreateBackground()
          allsprites = pygame.sprite.RenderPlain(MyShip)             
          while GameState==0:

              if randint(0,100)==50:
                  MyShip.gx = randint(0,640)
                  MyShip.gy = randint(100,400)
              allsprites.update()
              allsprites.draw(background)
              DrawText(background, 70, 10, "Welcome To Wibbly Wobbly Bridge",35,(255,0,0))
              DrawText(background, 70, 90, "A PyWeek Game in 7 Days By Davy Mitchell",25,(255,0,0))              
              DrawText(background, 70, 510, "Press the Space Bar to Begin",35,(255,0,0))
              DrawText(background, 70, 530, "Thanks to Fatfly for the treasure sound.",35,(255,0,0))  
              screen.blit(background, (0, 0))
              screen.blit(inst, [50, 120, 455, 340])
              for event in pygame.event.get():
                  if event.type == pygame.QUIT: 
                      sys.exit()
                  elif event.type == pygame.KEYDOWN: 
                      keystate = pygame.key.get_pressed()
                      if keystate[K_SPACE]:
                          GameState=1
              pygame.display.flip()
          
        if GameState == 1: # Game on!
            print "Game Screen"
            allsprites = []
            allsprites = pygame.sprite.RenderPlain(Bloke)
            Level = 1
            Levels = GameLevels()
            Levels.SetUpLevel(Level)
            Obssprites = Levels.ObsSprites            
            BridgeMove = Levels.BridgeMove
            
            background = CreateBackground()
            
            # Draw the bridge.
            B_Left=250
            Move = 1
            ManX = 50
            ManY = 500
            MoveLeft = False
            MoveRight = False
            MoveUp = False
            MoveDown = False
            
            LeftLimit = 100
            RightLimit = 400
            Shift = 1
            Score = 0
            Health = 100

            Treas1.gy = 20
            Bloke.gy = 575            
            
            Treas1.update()
            SpaceToMove = True
            HitSomething=False
            
            # Game Loop
            while GameState==1:
                if BridgeMove:
                  B_Left = B_Left + Move
                  if B_Left==RightLimit: Move = -1 * Shift
                  if B_Left<LeftLimit: Move = Shift
                  
                PrevManX=ManX
                PrevManY=ManY
                
                DrawBG(background, B_Left, 230, 10)
                DrawText(background, 13, 13, "Go!", 50, (133,255,0))
                DrawText(background, 513, 13, str(Score), 50, (133,255,0))
                
                DrawText(background, 513+2, 553+2, "Health : " + str(Health), 30, (255,255,255))
                DrawText(background, 513, 553, "Health : " + str(Health), 30, (0,255,0))
                DrawText(background, 13, 553, "Level : " + str(Level), 50, (0,255,0))
                
                #if len(pygame.sprite.spritecollide(Bloke, Obssprites, False))>0:
                #    DrawText(background, 13, 13, "Ouch!", 50, (255,0,0))
                #    Health = Health - 1
                
                if Obssprites!=None:
                  for obs in Obssprites:
                    if (not HitSomething) and obs.rect.colliderect(pygame.Rect((B_Left + ManX) - 12, ManY-12, Bloke.rect.width+4, Bloke.rect.height+4)):
                      SpaceToMove = False
                      HitSomething = True
                      DrawText(background, 53, 53, "Ouch!", 50, (255,0,0))
                      ouch.play()
                      Health = Health - 5
                      if Health<1: GameState=2
                
                if SpaceToMove: HitSomething=False
                
                #print Bloke.gx, Bloke.gy
                #print Treas1.gx, Treas1.gy
                
                if len(pygame.sprite.spritecollide(Bloke, treasprites, False))>0:
                    Score = Score + 100
                    yeahtreasure.play()
                    Level += 1
                    Levels.SetUpLevel(Level)
                    Obssprites = Levels.ObsSprites            
                    BridgeMove = Levels.BridgeMove
                    
                    if Treas1.gy < 100:
                        Treas1.gy = 575
                    else:
                        Treas1.gy = 25
                    
                for event in pygame.event.get():
                    if event.type == pygame.QUIT:
                        sys.exit()
                    elif event.type == pygame.KEYDOWN:
                        keystate = pygame.key.get_pressed()
                        if keystate[K_LEFT]:
                            MoveLeft = True
                            MoveRight = False
                        elif keystate[K_RIGHT]:
                            MoveRight = True
                            MoveLeft = False
                        elif keystate[K_UP]:
                            MoveUp = True
                            MoveDown = False
                            Bloke.FlipV("up")
                        elif keystate[K_DOWN]:
                            MoveDown = True
                            MoveUp = False
                            Bloke.FlipV("down")
                        elif keystate[K_SPACE]:
                            #Bloke.gx = Treas1.gx
                            #Bloke.gy = Treas1.gy
                            MoveDown = False
                            MoveUp = False
                    elif event.type == pygame.KEYUP:
                        keystate = pygame.key.get_pressed()
                        if not keystate[K_LEFT]:
                            MoveLeft = False
                        if not keystate[K_RIGHT]:
                            MoveRight = False
                        if not keystate[K_UP]:
                            MoveUp = False
                        if not keystate[K_DOWN]:
                            MoveDown = False
                            
                # Move things around!
                #---------------------
                if BridgeMove:
                  if randint(0,4)>1:
                    ManX = ManX + Move # bridge wobble
                SpaceToMove = True
                
                if MoveLeft:
                    ManX = ManX - 3
                elif MoveRight:
                    ManX = ManX + 3
                
                if Obssprites!=None:
                  for obs in Obssprites:
                    if obs.rect.colliderect(pygame.Rect((B_Left + ManX) - 10, ManY-10, Bloke.rect.width, Bloke.rect.height)):
                      SpaceToMove = False
                
                if MoveUp:
                    ManY = ManY - 2
                elif MoveDown:
                    ManY = ManY + 2
                
                if Obssprites!=None:
                  for obs in Obssprites:
                    if obs.rect.colliderect(pygame.Rect((B_Left + ManX) - 10, ManY-10, Bloke.rect.width, Bloke.rect.height)):
                      SpaceToMove = False                  
                
                if ManX<20: ManX=20
                if ManX>210: ManX=210
                if ManY<10: ManY=10
                if ManY>580: ManY=580
                
                if SpaceToMove:
                  Bloke.gx = (B_Left + ManX) - 10
                  Bloke.gy = ManY - 10
                else:
                  ManX = PrevManX
                  ManY = PrevManY
                  Bloke.gx = (B_Left + ManX) - 10
                  Bloke.gy = ManY - 10
                
                if Obssprites!=None:
                  for obs in Obssprites:
                    if obs.name[0]!="X":
                      obs.gx = B_Left + obs.LeftPos + Move
                #Obs1.gx = B_Left + 10 + Move #+ randint(2,4)
                #Obs2.gx = B_Left + 90 + Move #+ randint(2,4)
                #Obs3.gx = B_Left + 130 + Move #+ randint(2,4)
                
                Treas1.gx = B_Left + 100 + Move #+ randint(2,4)
                Treas1.gy = Treas1.gy
                
                #MB1.gx = B_Left + 100 + Move
                #MB1.gy = 400
                
                #FB1.gx = B_Left + 200 + Move
                #FB1.gy = 420
                
                #print Obs1.gx, Obs1.gy
                treasprites.update()
                allsprites.update()
                if Obssprites!=None: Obssprites.update()
                treasprites.draw(background)
                allsprites.draw(background)
                if Obssprites!=None:Obssprites.draw(background)
                
                #DrawText(background, 13, 153, str(Obs3.rect), 50, (205,0,0))
                #DrawText(background, 13, 223, str(Bloke.rect), 50, (205,0,0))
                #DrawText(background, 13, 323, str(ManX), 50, (205,0,0))
                #DrawText(background, 13, 423, str(ManY), 50, (205,0,0))
                
                screen.blit(background, (0, 0))
                
                # Flip Screen.
                pygame.display.flip()
        elif GameState==2:
              print "Game Over!"
              background = CreateBackground()
              
              while GameState==2:
                DrawText(background, 70, 200, "Game Over",75,(255,0,0))    
                screen.blit(background, (0, 0))
                for event in pygame.event.get():
                    if event.type == pygame.QUIT: 
                        sys.exit()
                    elif event.type == pygame.KEYDOWN: 
                        keystate = pygame.key.get_pressed()
                        if keystate[K_SPACE]:
                            GameState=0
                pygame.display.flip()        

